%define debug_packages ${nil}
%define debug_package ${nil}
%define _libmoddir /lib/modules
%define moduledir /kernel/drivers/input/misc
%define init_script pcoip_host
%define init_check_script pcoip_hostcheck
%define init_script_dir /etc/init.d
%define udev_rule 10-pcoip_host_udev.rules
%define udev_rule_dir /etc/udev/rules.d
%define lockscreen_script pcoip_lockscreen
%define usr_app pcoip_agent
%define usr_app_dir /usr/bin
%define installed_sources_dir /usr/src/pcoip_host/SOURCES
%define starthostsw_script pcoip_starthostsw
%define hostsw_daemon pcoiphostswd

%if %(test -f /etc/redhat-release && echo 1 || echo 0)
%define target redhat
%endif

%if %(test -f /etc/SuSE-release && echo 1 || echo 0)
%define target suse
%endif

Name: pcoip_host
License: GPL
Group: System/Kernel
Summary: Teradici PCoIP Host Software driver for RHEL 5/6
# the version of the application
Version: 4.1
# the packaging revision of this particular version
Release: 6%{?dist}
# this contains the software source code
Source0: %name-%version.tar.bz2
# system initialization script that runs when the system boots
Source1: %{init_script}
# the udev rule creates a properly named character file for the device in
# the /dev/input directory
Source2: %{udev_rule}
# the application that allows the user to configure and control the driver
Source3: %{usr_app}
# the initialization script that checks for kernel module and builds it
Source4: %{init_check_script}
# the script that locks the screen when a PCoIP session becomes disconnected
Source5: %{lockscreen_script}
# script used to start the host SW executable (pcoip_agent)
Source6: %{starthostsw_script}
# daemon which ensures the host SW executable (pcoip_agent) is runs when no one is logged in locally
Source7: %{hostsw_daemon}

%if 0%{?suse_version}
#%{echo:Using SUSE packages}
BuildRequires:  gcc, kernel-default-devel
Requires:       xorg-x11-libXfixes
%else
#%{echo:Not using SUSE packages}
BuildRequires:  gcc, kernel-devel
Requires:       libXfixes
%endif
BuildRoot: %{_tmppath}/%{name}.%{version}-build
%description
This is the PCoIP Host software driver for TERA12xx devices. The driver
interacts with the TERA12xx device to support the local cursor and keyboard
features of the device. The driver also supports setting/getting various
device configuration setting. It also supports gathering some statistics
maintained by the PCoIP devices.

# Prep Stanza begins here
#
%prep
# unpack the source code and cd into the source directory
%setup
set -- *

# Build Stanza begins here
#
%build

# Install Stanza begins here
#
%install

# as sanity make sure the Buildroot is empty
rm -rf $RPM_BUILD_ROOT

# install the kernel sources tarball
mkdir -p $RPM_BUILD_ROOT%{installed_sources_dir}
install -m 744 %{SOURCE0} $RPM_BUILD_ROOT%{installed_sources_dir}

# install the startup script
mkdir -p $RPM_BUILD_ROOT%{init_script_dir}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{init_script_dir}

# install the udev script
mkdir -p $RPM_BUILD_ROOT%{udev_rule_dir}
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{udev_rule_dir}

# install the application that controls/configures the driver
mkdir -p $RPM_BUILD_ROOT%{usr_app_dir}
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{usr_app_dir}

# install the kernel module check startup script
mkdir -p $RPM_BUILD_ROOT%{init_script_dir}
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{init_script_dir}

# install the script that locks the screen when a PCoIP session becomes disconnected
mkdir -p $RPM_BUILD_ROOT%{usr_app_dir}
install -m 755 %{SOURCE5} $RPM_BUILD_ROOT%{usr_app_dir}

# install the script used to start the Host SW
mkdir -p $RPM_BUILD_ROOT%{usr_app_dir}
install -m 755 %{SOURCE6} $RPM_BUILD_ROOT%{usr_app_dir}

# install the daemon
mkdir -p $RPM_BUILD_ROOT%{usr_app_dir}
install -m 755 %{SOURCE7} $RPM_BUILD_ROOT%{usr_app_dir}

%clean
rm -rf $RPM_BUILD_ROOT

# Post-install Stanza begins here (executed after the package is installed)
#
%post
if [ $1 == 2 ]; then
# this is an upgrade, so remove the kernel module to make sure it gets rebuilt
   /usr/bin/pkill pcoip_agent &> /dev/null
   /sbin/rmmod %{name} &> /dev/null
   rm -f %{_libmoddir}/`uname -r`%{moduledir}/%{name}.ko
else
   if [ %{target} == "suse" ]; then
#      echo "installing scripts using install_initd"
      /usr/lib/lsb/install_initd %{init_script}
      /usr/lib/lsb/install_initd %{init_check_script}
   elif [ %{target} == "redhat" ]; then
#      echo "installing scripts using chkconfig"
      /sbin/chkconfig --add %{init_script}
      /sbin/chkconfig --add %{init_check_script}
   else
      echo "Error: platform not supported by createRPM script (post)"
      exit 1
   fi
fi

sh %{init_script_dir}/%{init_check_script} start > /dev/null

# Pre-uninstall Stanza begins here (executed before the package is uninstalled)
#
%preun
if [ $1 == 0 ] ; then
   if [ %{target} == "suse" ]; then
#      echo "uninstalling scripts using remove_initd"
      /usr/lib/lsb/remove_initd %{init_script}
      /usr/lib/lsb/remove_initd %{init_check_script}
   elif [ %{target} == "redhat" ]; then
#      echo "uninstalling scripts using chkconfig"
      /sbin/chkconfig --del %{init_script}
      /sbin/chkconfig --del %{init_check_script}
   else
      echo "Error: platform not supported by createRPM script (preun)"
      exit 1
   fi
   rm -f %{init_script_dir}/%{init_script}
   rm -f %{init_script_dir}/%{init_check_script}
   rm -f %{udev_rule_dir}/%{udev_rule}
   rm -f %{usr_app_dir}/%{lockscreen_script}
   rm -f %{usr_app_dir}/%{usr_app}
   rm -f %{_libmoddir}/`uname -r`%{moduledir}/%{name}.ko
   rm -f %{installed_sources_dir}/%{init_script}
   rm -f %{installed_sources_dir}/%{init_check_script}
   rm -f %{installed_sources_dir}/%{udev_rule}
   rm -f %{installed_sources_dir}/%{lockscreen_script}
   rm -f %{installed_sources_dir}/%{usr_app}
fi

# Files Stanza begins here
#
%files
# set permission and ownership of packaged files
# the - indicates the current permissions on the files should be used
%defattr(-,root,root)
# package all files within the $RPM_BUILD_ROOT%{init_script} directory
%{init_script_dir}/*
# package all files within the $RPM_BUILD_ROOT%{udev_rule_dir} directory
%{udev_rule_dir}/*
# package all files within the $RPM_BUILD_ROOT%{usr_app_dir} directory
%{usr_app_dir}/*
# package all files within the $RPM_BUILD_ROOT%{installed_sources_dir} directory
%{installed_sources_dir}/*

# Changelog begins here
#
%changelog
* Tue Jul 16 2013 Teradici Corporation - 4.1.6
- Fixed spec file error that prevented the host SW from properly installing scripts on CentOS 6
* Fri Jul 12 2013 Teradici Corporation - 4.1.5
- Modified scripts to support SLED 11 SP 2
- Partially fixed bug 10061: Linux Host SW icon on the taskbar is displayed as a vertical line instead of the PCoIP icon
- Fixed a bug where the host SW asserts when one monitor is active on a port other than port 0
- Disable local cursor when user logs out while connected to host with a zero client
- Prevent root from starting host software executable
- Enable Apply button on UI Monitor tab if a valid monitor is configured for each screen
* Mon Jun 24 2013 Teradici Corporation - 4.1.4
- Fixed problem that sometimes prevented the Teradici soft client keyboard and mouse from working
- Modified daemon to enable relative cursor reports from soft clients when the login screen is active
* Tue Jun 18 2013 Teradici Corporation - 4.1.3
- Fixed problem where the host SW executable sends incorrect topology when the topology changes while a single monitor is active
* Fri Jun 07 2013 Teradici Corporation - 4.1.2
- Updated driver to handle relative cursor reports
- Updated daemon to enable relative cursor reports while the login screen is active
* Mon May 13 2013 Teradici Corporation - 4.1.1
- Changed default value of local cursor feature from disabled to enabled
- Modify Host SW to exit if running as root while a user is logged in locally
- Added command line option to specify the Host SW local configuration file
- Added command line option to control the Host SW logging level. Logging is disabled by default. This feature eliminates the need for two copies (debug and release) of the host SW executable.
* Wed Apr 24 2013 Teradici Corporation - 4.1.0
- Added support for using the Teradici soft client, this involved adding a daemon
- Added support for a global configuration file that allows admins to specify the default Host SW settings for new users
- Modified Host SW locking mechanism to eliminate the need to manually delete a lock file when Host SW terminates improperly
- Created pcoip_starthostsw script which starts the Host SW with optional parameters
- Fixed problem where the UI opens when the screen topology changes
- Modified Host SW to exit when the taskbar icon disappears
- Created class cTERA_CFG to manage the Host SW configuration setting
- Added command line option to specify the Host SW global configuration file
- Added command line option to specify the period of the remote cursor updates
- Fixed bug in code that displays the log message timestamp
- Renamed right-click Exit menu option to Restart Host SW when the daemon is running and no one is logged in locally
- Changed local cursor bitmap displayed when Host SW cannot display host cursor bitmap. The host SW now displays an arrow with an L character in it.
- Changed logging level of driver message from info to debug to avoid spamming the system log file when the host card resets unexpectedly
* Thu Jan 17 2013 Teradici Corporation - 4.0.8
- Fixed problem where the local cursor feature cannot be enabled when the file ~/.pcoip_agent does not exist when the pcoip_agent executable starts
* Mon Jan 14 2013 Teradici Corporation - 4.0.7
- Fixed problem introduced in release 4.0.0 where the local cursor feature does not work on CentOS 5.3 systems with one monitor
- Added support for moving the pcoip_lockscreen script to the directory containing the pcoip_agent executable
- Fixed problem observed on CentOS 6.2 where the local cursor is not visible after the client monitor(s) state changes from standby/off to on
* Tue Dec 18 2012 Teradici Corporation - 4.0.6
- Fixed compiler error observed on systems running kernel 3.4.11
- Fixed problem where the pcoip_agent executable could crash while processing large cursor bitmaps
- Added support for disabling the remote cursor synchronization feature
- Fixed problem where the security feature that locks the screen when a session is disconnected did not work on workstations running KDE
* Wed Oct 24 2012 Teradici Corporation - 4.0.5
- Fix local cursor feature problem that occurred when a monitor was not connected to the lowest numbered monitor port on the client (for example ports 1 and 4 instead of 1 and 2)
- Disable the "Hide the Local Cursor when idle" feature when only the Remote cursor is visible
* Mon Oct 22 2012 Teradici Corporation - 4.0.4
- Updated GUI to detect when TwinView is enabled using nvidia-settings --query
* Tue Oct 9 2012 Teradici Corporation - 4.0.3
- Integrated changes made by Dr. Stefan Genssler at MTU Aero Engines GmbH to add support for sending actual host cursor shapes to the client and hide the host (remote) cursor
- Updated layout of information on the host software GUI Monitor tab and added client screen size information
- Added support for disabling the disconnect and exit options on the agent right-click menu
- Added support for using cached cursor bitmaps stored on the client
- Fixed compiler warning in tera_gfun.c (DMA_nnBIT_MASK deprecated)
- Removed unused header file resolved some missing include file problems
- Added timestamp to GUI log messages in debug builds
- Updated tooltips displayed when the monitor configuration settings are not setup
- Display tooltip when system is configured to use separate X screens without Xinerama or TwinView enabled
- Refactored feature property page evt_apply_btn() function to use another function that does the same thing
* Tue Sep 11 2012 Teradici Corporation - 4.0.2
- Fixed problem where the local and host cursors are out of sync on CentOS 6 systems with multiple monitors with different sizes
* Thu Sep 6 2012 Teradici Corporation - 4.0.1
- Fixed problem where 4.0.0 did not work on CentOS 5.3
- Added support for using 2 monitors with TwinView enabled (this was broken in 4.0.0)
* Thu Aug 31 2012 Teradici Corporation - 4.0.0
- Added support for TERA2 (both host cards and zero clients)
* Thu May 17 2012 Teradici Corporation - 3.0.6
- Fix problem where incorrect timeout constants are used on distributions that do not provide a 1 ms clock tick
- Fix problem where log messages display inaccurate information on distributions that do not provide a 1 ms clock tick
* Fri May 4 2012 Teradici Corporation - 3.0.5
- Fixed problems compiling the driver on SLED SP2 (init_MUTEX deprecated, replaced ioctl with unlocked_ioctl)
* Fri May 4 2012 Teradici Corporation - 3.0.4
- Add support for enabling and configuring client keyboard repeat detection
* Thu May 3 2012 Teradici Corporation - 3.0.3
- Add support for configuring image quality preference setting
- Add support for multimedia keys while the local cursor feature is active
- Change frequency the HCC and HDC driver threads run. This change fixed a problem compiling on SLED SP1.
* Wed Apr 25 2012 Steven Seed <Steven.Seed@disneyanimation.com> - 3.0-2.1
- integrated version 3.0.2 with new SPEC to build kernel module during boot
* Wed Apr 18 2012 Teradici Corporation - 3.0.2
- Updated version to 3.0.2
* Wed May 18 2011 Steven Seed <Steven.Seed@disneyanimation.com> - 1.4-5.5
- Restructured SPEC and package to build kernel module on boot instead of prebuilding it

* Tue Nov 23 2010 Steven Seed <Steven.Seed@disneyanimation.com> - 1.4-5.3
- Rebuilt for kernel 2.6.32-71.7.1

* Mon Nov 1 2010 Steven Seed <Steven.Seed@disneyanimation.com> - 1.4-5.2
- Added check for upgrade vs. uninstall in %preun

* Fri Oct 16 2009 Teradici Corporation
- Initial beta release
