////////////////////////////////////////////////////////////////////////////
//   Copyright 2013  Teradici Corporation
//
//   This program is free software; you can redistribute it and/or modify it
//   under the terms and conditions of the GNU General Public License,
//   version 2, as published by the Free Software Foundation.
//
////////////////////////////////////////////////////////////////////////////
/// \file
/// \brief
///     Macros used to enable additional log messages
///
////////////////////////////////////////////////////////////////////////////

#pragma once

// ---- Include Files -------------------------------------------------------

// ---- Constants and Types -------------------------------------------------

// When HOST_CUR_BMP_DBG is defined the code outputs additional log messages
// that may help debug problems associated with reading the host cursor
// bitmap and sending the bitmap to the client
#undef HOST_CUR_BMP_DBG
//#define HOST_CUR_BMP_DBG                1

// Define the following macro to enable additional logging for the feature
// that sends cursor position updates from the host OS to the client
#undef UPDATE_CLIENT_CUR_POS_DBG
//#define UPDATE_CLIENT_CUR_POS_DBG       1

// When GFUN_DBG is defined the code outputs additional log messages
// related to the GFUN interfaces in the driver
#undef GFUN_DBG
//#define GFUN_DBG                        1

// ---- Variable Externs ----------------------------------------------------

// ---- Function Prototypes -------------------------------------------------


